/* \mainpage

mess882x -- RFC 822 Message parser and (s/)qmail helpers
========================================================

WHAT IT IS:
----------
- mess822x is a fork of D.J.B.'s mess822-0.58 package, 
- ported to fehQlibs(-16) and
- provided in the /slashpackage format accordingly.

WHAT IT INCLUDES:
----------------

- 822* and mess822 routines for RFC 2822 mail message
  handling covering the header and the body of the message
- tai* libraries for TAI time handling and formating,
  including reading, conversion between localtime and
  timezones.
- (s/)qmail add-ons handler and programs to be used
  in a dot-qmail file

mess822* AND 822* ROUTINES:
--------------------------

- 822body - display the body of a RFC 822 message
- 822date - read the date and time from a message
- 822field - read (and display) arbitrary fields in here
- 822header - print the header of the message
- 822mimeparts - disentangle MIME parts of a message
- 822print - read, re-structure, and dispay the message header
- 822received - show the 'Received' header fields
- b64decode/b64encode - generic BASE64 encoding + decoding
- qpdecode/qpencode - Quoted-printable encoding and decoding

RFC 2047 and RFC 4648 are respected. 

(s/)qmail's ADD-ONS:
--------------------

- ifvalidto - check if SMTP recipient is listed in To:/CC:;
  optionally bounce or redirect the mail
- iftocc - check if SMTP recipient is potentially in BCC:;
  optionally bounce the message
- new-inject - preprocess a message, including address
  rewriting and change of envelope sender
- ofmipd - accept outgoing mail through OFMIP,
  the Old-Fashioned Mail Injection Protocol 
- ofmipname - build a name-address database (cdb) 


LIBRARIES:
----------

After compilation the following two libraries are available:

- libtai.a:  time&date functions
- mess822.a: mail message parsing functions including
             base64 and quoted-printable primitives


REQUIREMENTS:
------------
- fehQlibs (>=25) -- can't build w/o it


INSTALLATION:
------------
- Read the doc/INSTALL document


DOCUMENTATION:
-------------
- Check the ./doc directory
- See doc/CHANGES for version information.


LEAPSECS.DAT:
------------
- An updated leapsecs.dat file will be installed under /etc.



mess822x (1.x) -- this README is not comprehensive yet 

Date: December, 11th, 2024 
