#include "buffer.h"
#include "logmsg.h"
#include "getln.h"
#include "mess822.h"
#include "case.h"
#include "exit.h"
#include "str.h"

#define WHO "822field"

static void nomem()
{
  logmsg(WHO,111,FATAL,"out of memory");
}

int flag;
stralloc value = {0};

mess822_header h = MESS822_HEADER;
mess822_action a[] = {
  { "subject", &flag, 0, &value, 0, 0, 0 } // initial values
, { 0, 0, 0, 0, 0, 0, 0 }  // occurances
} ;

stralloc line = {0};
int match;

/* The 'header' line may be word-wise encoded;
   we need to comply with this. 
*/

int header_decode(stralloc *header)
{
   unsigned char ch; 
   int seenq = 0;
   int mimetype = 0;
   int done = 0;

   stralloc in = {0};        // input for decoding
   stralloc out = {0};       // output of entire header line
   stralloc word = {0};      // result of decoding word/line
   if (!stralloc_copys(&in,"")) nomem();
   if (!stralloc_copys(&out,"")) nomem();

   for (int i = 0; i < header->len; i++) {
     ch = header->s[i];
     if (ch == '\0') goto DONE;
     if (i == header->len - 2 && ch == '=') goto DONE;

     if (ch == '?') seenq++;
     if (seenq == 2) {
     if (!stralloc_copys(&in,"")) nomem();
       if (ch == 'q' || ch == 'Q') {             // new QP word
          mimetype = 5; 
       } else if (ch == 'b' || ch == 'B') {      // new BASE64 word    
          mimetype = 3;
       }
       continue;
     }

   // Get Word or Line 

     if (mimetype) {
       if (seenq == 3 && ch != '?' && ch != ' ') if (!stralloc_append(&in,&ch)) nomem();
       if (seenq == 4) { done = 1; if (!stralloc_0(&in)) nomem(); }
       if (ch == ' ' || ch == '\n' || ch == '\t') { if (!stralloc_0(&in)) nomem(); done = 1; }
     } else if (ch != '=') {
       if (!stralloc_append(&in,&ch)) nomem();
     }

     if (i == header->len - 1) done = 1;        // nothing to follow
     if (!done) continue;

   // For each word or line -> decode 

     switch (mimetype) {
       case 0: if (!stralloc_0(&in)) nomem();
               if (!stralloc_catb(&out,in.s,in.len)) nomem();
               if (!stralloc_copys(&in,"")) nomem();
               done = 0;
               break;
       case 3: if (!stralloc_copys(&word,"")) nomem();
               if ((done = mess822_b64decode(&word,in.s,in.len,4648)) > 0) {
                 if (!stralloc_cat(&out,&word)) nomem();
                 if (!stralloc_0(&out)) nomem();
                 if (!stralloc_copys(&in,"")) nomem();
               } else {
                 logmsg(WHO,0,INFO,B("error decoding header: ",word.s));
                 if (!stralloc_catb(&out,in.s,in.len)) nomem();
               } done = 0; seenq = 0; mimetype = 0; break;
       case 5: if (!stralloc_copys(&word,"")) nomem();
               if ((done = mess822_qpdecode(&word,in.s,in.len,2047)) > 0) {
                 if (!stralloc_cat(&out,&word)) nomem();
                 if (!stralloc_0(&out)) nomem();
                 if (!stralloc_copys(&in,"")) nomem();
               } else {
                 if (!stralloc_catb(&out,in.s,in.len)) nomem();
                 logmsg(WHO,0,INFO,B("error decoding header: ",word.s));
                 if (!stralloc_catb(&out,in.s,in.len)) nomem();
               } done = 0; seenq = 0; mimetype = 0; break;
       }
   }



DONE:
  if (!stralloc_copyb(header,out.s,out.len)) nomem();
  if (!stralloc_append(header,"\n")) nomem();
  if (!stralloc_0(header)) nomem();

  return out.len - 1;
}

int main(int argc,char **argv)
{
  if (argv[1]) {
    if (*argv[1] == '+') {
      a->verbose = 1;
      if (str_len(argv[1]) == 1)
        a[0].name = "subject";
      else
        a[0].name = argv[1] + 1;
    } else
      a[0].name = argv[1];
  }

  if (!mess822_begin(&h,a)) nomem();

  for (;;) {
    if (getln(buffer_0,&line,&match,'\n') == -1)
      logmsg(WHO,111,FATAL,"unable to read input ");

    if (!mess822_ok(&line)) break;
    if (!mess822_line(&h,&line)) nomem();
    if (!match) break;
  }

  if (!mess822_end(&h)) nomem();
  header_decode(&value);
   
  buffer_putflush(buffer_1,value.s,value.len);

  _exit(flag ? 0 : 100);
}
