#include <unistd.h>
#include "buffer.h"
#include "readwrite.h"
#include "exit.h"

char outbuf[256];
buffer bo = BUFFER_INIT(write,1,outbuf,sizeof(outbuf));

static void spit(char *s)
{
  if (buffer_puts(&bo,s) == -1) _exit(111);
}

int main(int argc,char **argv)
{
  char *name;
  char *value;
  unsigned char ch;
  char octal[4];

  name = argv[1];
  if (!name) _exit(100);
  value = argv[2];
  if (!value) _exit(100);

  spit("char ");
  spit(name);
  spit("[] = \"\\\n");

  while ((ch = *value++)) {
    spit("\\");
    octal[3] = 0;
    octal[2] = '0' + (ch & 7); ch >>= 3;
    octal[1] = '0' + (ch & 7); ch >>= 3;
    octal[0] = '0' + (ch & 7);
    spit(octal);
  }

  spit("\\\n\";\n");
  if (buffer_flush(&bo) == -1) _exit(111);
  _exit(0);
}
