#ifndef MESS822_H
#define MESS822_H

#include "stralloc.h"
#include "caltime.h"

typedef struct {
  struct caltime ct;
  int known; /* 0 for ct uninitialized; 1 if ok; 2 if ok and right zone */
} mess822_time;

typedef struct {
  char *name; /* 0 means all names */
  int *flag;
  stralloc *copy;
  stralloc *value;  /* the 822 field */
  stralloc *addr;
  mess822_time *when;
  int verbose;
} mess822_action;

typedef struct {
  stralloc inprogress;
  mess822_action *action;
} mess822_header;

typedef struct {
	stralloc *type;
	stralloc *encoding;
  stralloc *name;
  stralloc *alias;
  int size;
  int state;
  int level;
//  mess822_mime *nextmime;
} mess822_mime;

/*
extern const char *mime_headers[] = {  // RFC 2045
  "MIME-Version:",
  "Content-Type:",
  "Content-Transfer-Encoding:",
  "Content-Disposition:",
  "Content-ID:"
};
*/

#define MESS822_HEADER { {0} }
#define MESS822_MIME { {0} }

extern int mess822_quoteplus(stralloc *,char *, char *);
extern int mess822_quote(stralloc *,char *, char *);
extern int mess822_quotelist(stralloc *,stralloc *);
extern int mess822_fold(stralloc *,stralloc *,char *,int);
extern int mess822_date(stralloc *,mess822_time *);

extern int mess822_token(stralloc *,char *);
extern int mess822_addrlist(stralloc *,char *);
extern int mess822_when(mess822_time *,char *);

extern int mess822_begin(mess822_header *,mess822_action *);
extern int mess822_line(mess822_header *,stralloc *);
extern int mess822_end(mess822_header *);
extern int mess822_ok(stralloc *);

extern int mess822_b64decode(stralloc *,const char *,int,int);
extern int mess822_b64encode(stralloc *,stralloc *);
extern int mess822_b64urlencode(stralloc *,stralloc *);
extern int mess822_qpdecode(stralloc *,const char *,int,int);
extern int mess822_qpencode(stralloc *,stralloc *);

#endif
